{****************************************************************************}
{                 DBFPROC v1.9b   Last mode 19.08.1995.                     }
{============================================================================}
{  ⥪ ࠡ⪨ 䠩   ⨯ .DBF  dBase,FoxBase,Clipper }
{  ।    䨪樨  ࠢ            }
{  Fido - 2:5019/3.8                                                         }
{     ⥫䮭  ᪥ - 9-20-55                           }
{============================================================================}
{   ⮬ ਠ ᯮ  TurboVision   樨     }
{  ॡ Turbo Pascal   6.0.                                       }
{      ᮦ,   ࠧ  묨 䠩,    }
{   ⮬ ,   ⠢  প ᮢ -  ࠡ⠥.     }
{   ᫨  -  ।  ⮬  -  ᨬ.        }
{****************************************************************************}
{$IFNDEF Ver70}
 {$IFNDEF Ver60}
  !! :    6.0 !!
 {$ENDIF}
{$ENDIF}
{$A+,I-,V-,N+,E+,D+}
unit DBFProc;
interface
uses
    Dos,Objects,Memory,DBF_IDX;

{----------------------------------------------------------------------------}
const
    dBase          = $03;  {   祭 }
    dBaseIIIMemo   = $83;  {  㫥      }
    FoxProMemo     = $F5;  {   䠩    }
    dBaseIVMemo    = $8B;  {   ࠧ ᨩ  }

    CopyRight = '  (C) ॥ ࣥ ஢ . ';


type
   PRFileHeader = ^RFileHeader;
   RFileHeader= record   { *** ࢠ   *** }
   {+0}      DBType,                           {  7 6 5 4 3 2 1 0
                                                          
                                                           ᨨ
                                                        
                                                        DBT [ DBASE IV]
                                                      ???
                                                       SQL [⮫쪮  DBASE IV]
                                                    
                                                   祭 䠩 DBT  }
   {+1}      Year,                            {  ᫥ 䨪樨 }
   {+2}      Month,                           {  ---------//-------- }
   {+3}      Day      : Byte;                 {   ---------//-------- }
   {+4}      RecCount : LongInt;              { ᫮ ᥩ  㤠}
   {+8}      Location : Integer;              {  ࢮ }
   {+10}     RecordLen: Integer;              {   }
   {+12}     Reserve1 : Word;                 {  }
   {+14}     FDelayTrans : Byte;              {  প ࠭樨 }
   {+15}     Reserve2 : Array[1..13] of Byte; { ࢭ  }
   {+28}     FlagMDX : Boolean;               {  祭 ⢥-
                                                  1 -  䠩
                                                .MDX, 0 -  }
   {+29}     Reserve3 : Array[1..3] of Byte;  {  }
            end;

{............................................................................}
type
    TFieldName = Array[1..11] of Char;

    PRDescriptor = ^RDescriptor;
    RDescriptor = record   { ***  (ਯ)  *** }
    {+0}     FieldName : TFieldName;           {   }
    {+11}    FieldType : Char;                 {   C,D,L,N,M}
    {+12}    FieldDisp : LongInt;              { 饭    }
    {+16}    FieldLen,                         {   }
    {+17}    FieldDec  : Byte;                 {   ᫥ 窨 }
    {+18}    A1 : Array[1..13] of Byte;        {  }
    {+31}    FlagTagMDX : Boolean;             {  ⥣ ᭮
                                                 䠩 MDX, 1 -  -
                                                 ஢, 0 -  }
            end;

    PDescriptor = ^TDescriptor; { ⥫   (ਯ) }
    TDescriptor = Object(TObject)  { ***  (ਯ)  *** }
             FieldName : TFieldName;           {   }
             FieldType : Char;                 {   C,D,L,N,M}
             FieldDisp : LongInt;              { 饭    }
             FieldLen,                         {   }
             Fielddec  : Byte;                 {   ᫥ 窨 }
             A1 : Array[1..13] of Byte;        {  }
             FlagTagMDX : Boolean;             {  ⥣ ᭮
                                                 䠩 MDX }
             constructor Init(DRec : RDescriptor);
             procedure   GetData(var DRec: RDescriptor);
             function    GetName : String;
             function    GetType : Char;
            end;

{............................................................................}
const
  MaxLenDBFRec = 8192;  { ᨬ쭠   }
  MaxDescCount = 256;   { ᨬ쭮 ᫮   }
  MaxLenDBFField = 255; { ᨬ쭠   }

  First        = True;
  Next         = False;

type
  PChArray = ^TChArray;
  TChArray = Array[0..MaxLenDBFRec] of Char;

{............................................................................}
type
PDBF = ^TDBF;
TDBF = Object(TObject)
    Errors        : Byte;   {  ﭨ 䠩,  訡 }
    FlagInit      : Byte;   { ਧ ᯥ譮 樠樨 ꥪ }
    DBFName       : String[64]; {  䠩   }

private
    FlagHd : Byte; {  ﭨ  . 254 -  }
    FlagCreate    : Boolean; {  ࠧ襭/  ᮧ 䠩 }
    DBFile        : File;  {   .DBF }
    DBFHeader     : RFileHeader;  {     䠩 }
    Descriptor    : RDescriptor;  {  ਯ  }
    DescriptorList: PCollection;  {  㪠⥫ ਯ஢}

    Indicator: LongInt;     { ⥫ ⥪饩 - 㪠뢠 䨧 }
                            { ( )  䠩  ਭ 祭 }
                            {  0  DBFHeader.NRecords-1, ᫥ 権 }
                            { ⥭/ 㪠뢠  ᫥ . }

    RecBuf   : TChArray;    { ७  }
    RecPoint : LongInt;     { ⥫ ᮫⭮ ( ) 樨  䠩 }

    DbfNdxList   : PCollection;
    DbfNdxActv   : Boolean;

public
{----------------------------------------------------------------------------}
    constructor Init(Name : String);  { ⨥   }
    destructor  Done; virtual;        { ⨥  }

    procedure CreateHeader(FType : Byte);
                                 { ⮢ ⮣  }
                                 { FType - ⨯ 䠩 dBase,dBaseIIIMemo...}

    procedure WriteHeader;  {    䠩 }

{...........................................................................}

    procedure AppendField(Name : String; FTp : Char; LenI,LenD : Byte);
                                  {   Name   ⮩  }
    function  GetNumField(Name : String) :Integer;
                                  {     Name     }
    function  GetFieldName(Num : Integer) :String;
                                  {         }
    function  GetFieldNum(Num : Integer) :String;
                                  {       祭 }
    function  GetField(Name : String) :String;
                                  {  祭  Name }
    function  GetTypeNum(Num : Integer) :Char;
                                  {  ⨯   Num }
    function  GetType(Name : String) :Char;
                                  {  ⨯  Name }
    function  GetLengthNum(Num : Integer): Integer;
                                  {      }
    function  GetLength(Name : String): Integer;
                                  {      }
    function  GetDispNum(Num : Integer): Integer;
                                  {  ᬥ饭    }
    function  GetDisp(Name : String): Integer;
                                  {  ᬥ饭    }
    procedure ModifyFieldNum(Num :Integer; Par:String);
                                  {  祭  Num  Par }
    procedure ModifyField(Name :String; Par:String);
                                  {  祭  Name  Par }

{...........................................................................}

    procedure SetPosition(Num : LongInt);
                                  { ⠭ 䠩   Num;
                                    0-᫥}
    procedure ReadRecord(Num : LongInt);
                                  {   0 - ।,
                                                    nn-  }
    procedure WriteRecord(Num : LongInt);
                                  {   0 -  ⥪ 
                                              nn-   }
    procedure TruncateBase(Num : LongInt);
                                  { १    Num }
                                  { Num = 0 - ⥪  }
    procedure DeleteRecord(Num : LongInt);
                                  {    㤠 }
                                  { 0 -  ⥪ 
                                    nn-   }
    procedure RestoreRecord(Num : LongInt);
                                  {   㤠   }
                                  { 0 -  ⥪ 
                                    nn-   }
    function  SearchRecord(Field,Key :String; Start : Boolean) :LongInt;
                                   {     Key   Field}
                                   { Start = First -   ࢮ  }
                                   { Start = Next -   ⥪饩  }
    function  CountRecs :LongInt;
                                   {  ᫮ ᥩ   }
    function  GetFileSize : LongInt;
                                   {  ࠧ    }
    function  CountDescriptors : Word;
                                 {  ᫮ ਯ஢   }
    procedure GetLastMode(var D,M,Y : Byte);
                                 {   ᫥ 䨪樨 }
    procedure Index (IName : String);
end;

{--------------------------------------------------------------------}
{*** ८ࠧ ⨯ ***}
function  RealToString(D : Double; Ln,Dc : Integer) : String;
                                                 { ᭮  ப }
function  StringToReal(S: String) : Double; { ப  ᭮ }
function  StringToInteger(S: String) : LongInt; { ப  楫 }
function  SpaceCut(DString: String): String;
function  UpString(DString :String) :String;

procedure SetMaxFiles(Count:Word);

implementation
{----------------------------------------------------------------------------}
function SpaceCut(DString: String): String;
var
  I : Byte;
  S : String;
begin
  S := DString;
  I := Length(S);
  while (S[I] in [' ',#0,#255]) and (I > 0) do Dec(I);
  S[0] := Chr(I);
  if I > 0 then
   begin
     I := 1;
     while S[I] in [' ',#0,#255] do Inc(I);
     SpaceCut := Copy(S,I,Length(S));
   end
    else SpaceCut := '';
end;

{........................................................................}
function  UpString(DString :String) :String;
const
 AltTable : Array[0..255] of Char = (
  #0,  #1,  #2,  #3,  #4,  #5,  #6,  #7,
  #8,  #9,  #10, #11, #12, #13, #14, #15,
  #16, #17, #18, #19, #20, #21, #22, #23,
  #24, #25, #26, #27, #28, #29, #30, #31,
  #32, #33, #34, #35, #36, #37, #38, #39,
  #40, #41, #42, #43, #44, #45, #46, #47,
  #48, #49, #50, #51, #52, #53, #54, #55,
  #56, #57, #58, #59, #60, #61, #62, #63,
  #64, #65, #66, #67, #68, #69, #70, #71,
  #72, #73, #74, #75, #76, #77, #78, #79,
  #80, #81, #82, #83, #84, #85, #86, #87,
  #88, #89, #90, #91, #92, #93, #94, #95,
  #96, 'A', 'B', 'C', 'D', 'E', 'F', 'G',
  'H', 'I', 'J', 'K', 'L', 'M', 'N', 'O',
  'P', 'Q', 'R', 'S', 'T', 'U', 'V', 'W',
  'X', 'Y', 'Z',#123,#124,#125,#126,#127,
  '', '', '', '', '', '', '', '',
  '', '', '', '', '', '', '', '',
  '', '', '', '', '', '', '', '',
  '', '', '', '', '', '', '', '',
  '', '', '', '', '', '', '', '',
  '', '', '', '', '', '', '', '',
 #176,#177,#178,#179,#180,#181,#182,#183,
 #184,#185,#186,#187,#188,#189,#190,#191,
 #192,#193,#194,#195,#196,#197,#198,#199,
 #200,#201,#202,#203,#204,#205,#206,#207,
 #208,#209,#210,#211,#212,#213,#214,#215,
 #216,#217,#218,#219,#220,#221,#222,#223,
  '', '', '', '', '', '', '', '',
  '', '', '', '', '', '', '', '',
  '', '',#242,#243,#244,#245,#246,#247,
 #248,#249,#250,#251,#252,#253,#254,#255);
var
   I : Integer;
begin
  UpString[0] := DString[0];
  for I := 1 to Length(DString) do UpString[I] := AltTable[Byte(DString[I])];
end;

{............................................................................}
constructor TDescriptor.Init;
begin
{$IFDEF Ver60}
  TObject.Init;
{$ELSE}
  inherited Init;
{$ENDIF}
  FieldName := DRec.FieldName;
  FieldType := UpCase(DRec.FieldType);
  FieldDisp := DRec.FieldDisp;
  FieldLen  := DRec.FieldLen;
  FieldDec  := DRec.FieldDec;
  FillChar(A1,13,0);
  FlagTagMDX := DRec.FlagTagMDX;
end;

{............................................................................}
procedure TDescriptor.GetData;
begin
  DRec.FieldName := FieldName;
  DRec.FieldType := FieldType;
  DRec.FieldDisp := FieldDisp;
  DRec.FieldLen  := FieldLen;
  DRec.FieldDec  := FieldDec;
  FillChar(DRec.A1,13,0);
  DRec.FlagTagMDX := FlagTagMDX;
end;

{............................................................................}
function TDescriptor.GetName;
var
  S : String;
  B : Byte;
begin
  S := '';
  for B := 1 to 10 do
   begin
     if FieldName[B] = #0 then Break
                          else S := S+ FieldName[B];
   end;
  GetName := UpString(SpaceCut(S));
end;

{............................................................................}
function TDescriptor.GetType;
begin
  GetType := UpCase(FieldType);
end;

{............................................................................}
constructor TDBF.Init(Name : String);
var
  Res,I : Integer;
  DispField,W : Word;
  SRec : SearchRec;

  D: DirStr;
  N: NameStr;
  E: ExtStr;

  begin
{$IFDEF Ver60}
    TObject.Init;
{$ELSE}
    inherited Init;
{$ENDIF}
    FlagCreate := True;
    Errors := 0;
    FlagHd  := 255;
    Indicator := 0;
    DescriptorList := nil;
  {........................................................}
  {      (ᮧ) 䠩            }
  {........................................................}

    FSplit(Name,D,N,E);
    if SpaceCut(N) = '' then { ᫨   ... }
     begin
      FlagInit := 0;
      Errors := 103;     { ... ⠭  訡 ... }
      Exit               { ...  訬 ࠡ . }
     end;

    if E = '' then E := '.DBF';
    DBFName := D+N+E;

    System.Assign(DBFile,DBFName);  {***     ***}

    if DOSError in [2..11] then { ᫨ 䠩  易 ... }
     begin
      FlagInit := 0;
      Errors := 100+DosError;    { ... ⠭  訡 ... }
      Exit               { ...  訬 ࠡ . }
     end;

  {........................................................}
   FindFirst(DBFName,AnyFile, SRec);
   if not ((DosError = 0) and
          (Pos('?', DBFName) = 0) and
          (Pos('*', DBFName) = 0)) then  { ᫨  䠩 ... }
     BEGIN             {***    ***}
      if FlagCreate then   { ᫨ ࠧ襭 ᮧ 䠩 ...}
       begin
         System.Rewrite(DBFile,1);  { ... c 䠩... }
         Errors := IOResult;
         if Errors > 0 then
          begin
            FlagInit := 0;
            Inc(Errors,100); { 㤠筠 ⪠ ᮧ }
            Exit
          end
            else
          begin
             Errors := 1;  {  㤠筮 ᮧ }
             FlagCreate  := False;  { ⨬ ᮧ }
          end;
       end
         else
       begin
         FlagInit := 0;
         Errors := 2; {      ᮧ }
         Exit;
       end;
     END
          ELSE       { ...  - ᫨ 䠩  ... }

     BEGIN      {***    ***}
       System.Reset(DBFile,1); { ... ஥ 䠩  䨪樨 ... }
       Errors := IOResult;
       if Errors > 0 then
        begin
          FlagInit := 0;
          Inc(Errors,100); {    }
          Exit
        end;

       if System.FileSize(DBFile) = 0 then  { ᫨ 䠩  }
        begin
          Errors := 1;  {   }
          FlagCreate  := False;  { ⨬ ᮧ }
          FlagInit := 123;
          Exit;
        end;

       {........................................................}
       {     ⥭   ࠡ⪨ ࠬ஢        }
       {........................................................}

       BlockRead(DBFile,DBFHeader,32,Res);{ ⥬    }
       if Res <> SizeOf(DBFHeader) then  { ᫨ ⠭  祬  }
        begin
          FlagInit := 0;
          Errors := 100;
          Exit;
        end;

       DispField := 1;  { 砫쭮 祭 ᬥ饭 = 1 }

       DescriptorList := New(PCollection,Init(20,10)); {   }

       for I := 1 to Pred(DBFHeader.Location div 32) do
        begin                   { ⥬    ᯨ᮪ }
          if not Eof(DBFile) then { ᫨ 䠩  稫 ... }
            begin
              BlockRead(DBFile,Descriptor,32,Res);
              Errors := IOResult;
              if Errors > 0 then
                begin
                  FlagInit := 0;
                  Inc(Errors,100);
                  Dispose(DescriptorList,Done);
                  Exit
                end;

              if MaxAvail < 32 then { ᫨   }
                begin
                  FlagInit := 0;
                  Errors := 8;
                  Dispose(DescriptorList,Done);
                  Exit
                end;

              with Descriptor do
                begin
                  {----------- ࠭ 祭 ᬥ饭  --------}
                  FieldDisp := DispField;
                  Inc(DispField,FieldLen);
                end;
              DescriptorList^.Insert(New(PDescriptor,Init(Descriptor)));
            end;
        end;
       FlagHd := 254;  {   樠஢ ⥫쭮 ! }
       FlagCreate := False; { ⨬ ᮧ }
       Errors := 0;
     END;

   FillChar(RecBuf,SizeOf(RecBuf),' '); { ⨬  }

   DbfNdxList := Nil;
   DbfNdxActv := False;

   FlagInit := 123;
  end;

{............................................................................}
destructor TDBF.Done;
  begin
    if FlagInit =123 then
     begin
       if FlagHd =254 then WriteHeader;

       if DbfNdxList <> nil then
           Dispose(DbfNdxList,Done); { ⮦ ᯨ᮪ ᮢ }

       System.Close(DBFile); { ஥ 䠩  }

      { ᢮ १ࢨ஢  }
       if DescriptorList <> nil then Dispose(DescriptorList,Done);
       FlagInit := 0;
      {$IFDEF Ver60}
       TObject.Done;
      {$ELSE}
       inherited Done;
      {$ENDIF}
     end;
  end;

{............................................................................}
{  ⮢ ⮩                                               }
{............................................................................}
procedure TDBF.CreateHeader(FType : Byte);
var
 Y,M,D,DW : Word;
begin
   if FlagHd =254 then Exit;

   FillChar(DBFHeader,32,#0);

   with DBFHeader do
    begin
     DBType := FType;
     GetDate(Y,M,D,DW);
     Year  := Y - 1900;
     Month := M;
     Day   := D;
     Location  := 33;
     RecordLen := 1;
    end;

    FlagHd := 254; { ⨬  樠 }
end;

{............................................................................}
{     䠩                                                 }
{............................................................................}
procedure TDBF.WriteHeader;
var
 I,Res : Integer;
 B : Byte;
  begin
     if (FlagInit <> 123) or
        (FlagHd <> 254) then Exit;

     Seek(DBFile,0);  { ⠭  砫 䠩 }

     BlockWrite(DBFile,DBFHeader,32,Res); { ࠭   }
     Errors := IOResult;
     if Errors > 0 then
      begin
       Inc(Errors,100);
       Exit;
      end;

     if DescriptorList^.Count > 0 then  { ᫨ ।  ... }
      for I := 0 to Pred(DescriptorList^.Count) do  { ...  横 ... }
       begin                     { ... ࠭  ᠭ  䠩 }
        PDescriptor(DescriptorList^.At(I))^.GetData(Descriptor);

        BlockWrite(DBFile,Descriptor,32,Res);
        Errors := IOResult;
        if Errors > 0 then
         begin
           Inc(Errors,100);
           Exit;
         end;
       end;

     B := $0D;
     BlockWrite(DBFile,B,1,Res);
     with DBFHeader do Seek(DBFile,Indicator *RecordLen +Location);
  end;

{............................................................................}
{                                                }
{............................................................................}
procedure TDBF.AppendField(Name : String; FTp : Char; LenI,LenD : Byte);
var
  I  : Integer;
  PD : PDescriptor;

 begin
    if (FlagInit <> 123) or { ᫨    ࠢ 䠩 }
       (DBFHeader.RecCount > 0) then Exit; { ᫨ 㦥   - ⮨ ᪮ !}

    if DescriptorList = nil then  { ᫨  ᯨ᪠ ਯ஢ }
     begin
       if MaxAvail < 32 * 20 then { ᫨   }
        begin
          Errors := 8;
          Exit
        end;
        { १ࢨ஢   ᯨ᮪ ਯ஢ }
        DescriptorList := New(PCollection,Init(20,10));
     end;

    FillChar(Descriptor,SizeOf(Descriptor),#0); { ⨬ ਯ }


    with Descriptor do {  ਯ }
     begin
       Name := UpString(SpaceCut(Name)); { ਢ   孥 ॣ }
       if Length(Name) > 10 then Name := Copy(Name,1,10);
       Move(Name[1],FieldName[1],Length(Name)); { ࠭   }
       FieldType := UpCase(FTp);  {   }

       case FieldType of
       'C': begin
              FieldLen := LenI;  {  ப }
              FieldDec := 0;
            end;
       'D': begin
              FieldLen := 8;     {   }
              FieldDec := 0;
            end;
       'L': begin
              FieldLen := 1;     {    㫥᪮ ६ }
              FieldDec := 0;
            end;
       'M': begin
              FieldLen := 10;    {  MEMO }
              FieldDec := 0;
            end;
       'N': begin
              if LenI > 15 then FieldLen := 15
                           else FieldLen := LenI;  {   }
              if LenD > Pred(LenI) then FieldDec := Pred(LenI)
                                   else FieldDec := LenD;
            end;
       end;

       Inc(DBFHeader.Location,32);
       Inc(DBFHeader.RecordLen,FieldLen);
     end;

    if MaxAvail < 32 then { ᫨   }
     begin
       Errors := 8;
       Exit
     end;

    if DescriptorList^.Count = 0 then Descriptor.FieldDisp := 1
      else
       begin
         with DescriptorList^ do PD := PDescriptor(At(Pred(Count)));
         with Descriptor do FieldDisp := PD^.FieldDisp+PD^.FieldLen;
       end;

    DescriptorList^.Insert(New(PDescriptor,Init(Descriptor)));
 end;

{............................................................................}
function  TDBF.GetNumField(Name : String) :Integer;
var
  S0,S1 : String;
  I : Integer;

begin
  if (FlagInit = 123) then
   begin
     S0 := UpString(SpaceCut(Name));
     if S0 <> '' then
      for I := 0 to Pred(DescriptorList^.Count) do
       begin
         S1 := PDescriptor(DescriptorList^.At(I))^.GetName;
         if S0 = S1 then
          begin
            GetNumField := I;
            Exit;
          end;
       end;
   end;
   GetNumField := -1;
end;

{............................................................................}
function  TDBF.GetFieldName;
begin
  if Num <= Pred(DescriptorList^.Count) then
    GetFieldName := PDescriptor(DescriptorList^.At(Num))^.GetName
   else GetFieldname := '';
end;

{............................................................................}
function  TDBF.GetFieldNum(Num : Integer) :String;
var
 B   : Byte;
 S   : String;
 Buf : Array[1..MaxLenDBFField] of Char;
 PD  : PDescriptor;

 begin
   if (FlagInit <> 123) or
      (FlagHd <> 254) then Exit;

   if Num > Pred(DescriptorList^.Count) then
               begin
                 GetFieldNum := '';
                 Exit;
               end;

   PD := PDescriptor(DescriptorList^.At(Num));
   FillChar(Buf,PD^.FieldLen+1,#0); { ⨬  }
   Move(RecBuf[PD^.FieldDisp],Buf[1],PD^.FieldLen);

   S := '';
   for B := 1 to PD^.FieldLen do
    begin
      if Buf[B] = #0 then Break
                     else S := S+ Buf[B];
    end;
   S := UpString(SpaceCut(S));

   case UpCase(PD^.FieldType) of
    'D': if Length(S) = 8 then
           GetFieldNum := Copy(S,7,2) +'.'+
                          Copy(S,5,2) +'.'+
                          Copy(S,3,2)
           else GetFieldNum := '  .  .  ';

    'C','L','M','N':  GetFieldNum := S;
   end; {End Case ... }
 end;

{............................................................................}
function  TDBF.GetField(Name : String) :String;
var
 NF : Integer;

begin
  if FlagHd =254 then
   begin
     NF := GetNumField(Name);
     if NF = -1 then GetField := ''
                else GetField := GetFieldNum(NF);
   end;
end;

{............................................................................}
function  TDBF.GetTypeNum(Num : Integer) :Char;
  begin
   if (FlagInit <> 123) or
      (FlagHd <> 254) then Exit;

   if Num > Pred(DescriptorList^.Count) then
               begin
                 GetTypeNum := #0;
                 Exit;
               end;

     GetTypeNum := PDescriptor(DescriptorList^.At(Num))^.GetType;
  end;

{............................................................................}
function  TDBF.GetType(Name : String) :Char;
var
 NF : Integer;
  begin
   if (FlagInit <> 123) or
      (FlagHd <> 254) then Exit;

   NF := GetNumField(Name);

   if NF = -1 then {   }
               begin
                 GetType := #0;
                 Exit;
               end;

   GetType := PDescriptor(DescriptorList^.At(NF))^.GetType;
  end;

{............................................................................}
function TDBF.GetLengthNum(Num : Integer): Integer;
  begin
   if (FlagInit <> 123) or
      (FlagHd <> 254) then Exit;

   if Num > Pred(DescriptorList^.Count) then
               begin
                 GetLengthNum := 0;
                 Exit;
               end;

     GetLengthNum := PDescriptor(DescriptorList^.At(Num))^.FieldLen;
  end;

{............................................................................}
function TDBF.GetLength(Name : String): Integer;
var
 NF : Integer;

 begin
   if (FlagInit <> 123) or
      (FlagHd <> 254) then Exit;

   NF := GetNumField(Name);

   if NF = -1 then {   }
               begin
                 GetLength := 0;
                 Exit;
               end;

   GetLength := PDescriptor(DescriptorList^.At(NF))^.FieldLen;
 end;

{............................................................................}
function TDBF.GetDispNum(Num : Integer): Integer;
  begin
   if (FlagInit <> 123) or
      (FlagHd <> 254) then Exit;

   if Num > Pred(DescriptorList^.Count) then
               begin
                 GetDispNum := 0;
                 Exit;
               end;

     GetDispNum := PDescriptor(DescriptorList^.At(Num))^.FieldDisp;
  end;

{............................................................................}
function TDBF.GetDisp(Name : String): Integer;
var
 NF : Integer;

 begin
   if (FlagInit <> 123) or
      (FlagHd <> 254) then Exit;

   NF := GetNumField(Name);

   if NF = -1 then {   }
               begin
                 GetDisp := 0;
                 Exit;
               end;

   GetDisp := PDescriptor(DescriptorList^.At(NF))^.FieldDisp;
 end;

{............................................................................}
procedure TDBF.ModifyFieldNum(Num :Integer; Par:String);
var
 Dsp,L : Integer;
 S0,S1 : String;
 PD    : PDescriptor;

 begin
   if (FlagInit <> 123) or
      (FlagHd <> 254) then Exit;

   if Num > Pred(DescriptorList^.Count) then
               begin
                 Errors := 254;
                 Exit;
               end;

   S0 := UpString(Par);
   PD := PDescriptor(DescriptorList^.At(Num));
   Dsp := PD^.FieldDisp;
   FillChar(RecBuf[Dsp],PD^.FieldLen,' ');

   case UpCase(PD^.FieldType) of
    'D': begin
           S1 := SpaceCut(S0);
           if (S1 <> '/  /') and
              (S1 <> '//') and
              (S1 <> '.  .') and
              (S1 <> '..') and
              (S1 <> '') then
            begin
              S1 := '19';
              Move(S1[1],RecBuf[Dsp],2);
              Move(S0[7],RecBuf[Dsp+2],2);
              Move(S0[4],RecBuf[Dsp+4],2);
              Move(S0[1],RecBuf[Dsp+6],2);
            end
             else
            begin
              S0 := '        ';
              Move(S0[1],RecBuf[Dsp],8);
            end;
         end;

    'C','L','M':
         begin
           S0 := SpaceCut(S0);
           if S0[0] > #0 then Move(S0[1],RecBuf[Dsp],Length(S0));
         end;

    'N': begin
           S0 := SpaceCut(S0);
           if PD^.FieldDec > 0 then { ᫨  ᨬ ᫥ 窨 - }
             begin               { ஢ਬ  窨 }
               if Pos(',',S0) > 0 then S0[Pos(',',S0)] := '.';

               if (Pos('.',S0) = 0) then { ᫨ 窠  - }
                begin                    {   }
                  FillChar(S1,15,'0');
                  S1[1] := '.';
                  S1[0] := Chr(PD^.FieldDec+1);
                  S0 := S0 +S1
                end;
                if Length(S0) > PD^.FieldLen then S0 := '0'+S1;
              end
              else if Length(S0) > PD^.FieldLen then S0 := '0';

            if Length(S0) < PD^.FieldLen then { ᫨  ப  }
              begin                          {   - 㤫 ப }
                FillChar(S1,15,' ');
                S1[0] := Chr(PD^.FieldLen -Length(S0));
                S0 := S1 +S0;
              end;

            Move(S0[1],RecBuf[Dsp],PD^.FieldLen);
         end;
   end;  { End Case ... }
 end;

{............................................................................}
procedure TDBF.ModifyField(Name :String; Par:String);
var
 I : Integer;

begin
  if FlagHd = 254 then
   begin
     I := GetNumField(Name);
     if I = -1 then Exit;
     ModifyFieldNum(I,Par);
   end;
end;

{............................................................................}
procedure TDBF.SetPosition;
var
 NR,OI : LongInt;
 I : Integer;

begin
   Errors := 0;

   if (FlagInit <> 123) or
      (FlagHd <> 254) then Exit;

   if Num = 0 then NR := Succ(Indicator)
              else NR := Pred(Num);

   with DBFHeader do
   begin
     if (Num > RecCount) or (RecCount = 0) then
      begin
        Errors := 254;
        Exit
      end;

     RecPoint := NR *RecordLen +Location;

     if FilePos(DBFile) <> RecPoint then
      begin
        OI := Indicator;
        Seek(DBFile,RecPoint);
        Errors := IOResult;
        if Errors > 0 then
          begin
            Seek(DBFile,OI *RecordLen +Location);
            Exit;
          end;
      end;

     Indicator := NR;
   end;
end;

{............................................................................}
procedure TDBF.ReadRecord;
var
 NR : LongInt;
 I : Integer;

begin
   Errors := 0;

   if (FlagInit <> 123) or
      (FlagHd <> 254) then Exit;

   case Num of
    0:   NR := Indicator;
    else NR := Pred(Num)
   end;

   with DBFHeader do
   begin
     if (Num > RecCount) or (RecCount = 0) then
      begin
        Errors := 254;
        Exit
      end;

     RecPoint := NR *RecordLen +Location;

     if FilePos(DBFile) <> RecPoint then
      begin
        Seek(DBFile,RecPoint);
        Errors := IOResult;
        if Errors > 0 then Exit;
      end;

     FillChar(RecBuf,RecordLen,' '); { ⨬  }
     BlockRead(DBFile,RecBuf,RecordLen,I);   { ⥬  }
     Errors := IOResult;
     if Errors > 0 then
      begin
        Seek(DBFile,RecPoint);
        Indicator := NR;
        Exit;
      end;

     Indicator := Succ(NR);
   end;
end;

{............................................................................}
procedure TDBF.WriteRecord;
var
 I : Integer;
 B : Byte;

begin
   Errors := 0;
   if (FlagInit <> 123) or
      (FlagHd <> 254) then Exit;

   with DBFHeader do
   begin
     if Num > Succ(RecCount) then { ᫨ 室  । 䠩 }
       begin
         Errors := 254;
         Exit;
       end;

     if RecCount = 0 then RecPoint := Location
                 else
            begin
             case Num of
              0:   RecPoint := Indicator *RecordLen +Location;
              else RecPoint := Pred(Num) *RecordLen +Location;
             end;
            end;

     if FilePos(DBFile) <> RecPoint then
       begin
         Seek(DBFile,RecPoint);
         Errors := IOResult;
         if Errors > 0 then Exit;
       end;

     BlockWrite(DBFile,RecBuf,RecordLen,I);
     Errors := IOResult;

     case Num of
      0:   Inc(Indicator);
      else Indicator := Num;
     end;

     if Indicator > RecCount then
      begin
        B := $1A;
        BlockWrite(DBFile,B,1,I);
        Errors := IOResult;
        Inc(RecCount);
        WriteHeader;
      end;
   end;
end;

{............................................................................}
procedure TDBF.TruncateBase(Num : LongInt);
var
  B : Byte;
  I : Integer;
  NR : LongInt;
begin
   Errors := 0;

   if (FlagInit <> 123) or
      (FlagHd <> 254) then Exit;

   case Num of
    0:   NR := Succ(Indicator);
    else NR := Num
   end;

   with DBFHeader do
   begin
     if (NR > RecCount) or (RecCount = 0) then
      begin
        Errors := 254;
        Exit
      end;

     RecPoint := NR *RecordLen +Location;

     if FilePos(DBFile) <> RecPoint then
      begin
        Seek(DBFile,RecPoint);
        Errors := IOResult;
        if Errors > 0 then Exit;
      end;

     B := $1A;
     BlockWrite(DBFile,B,1,I);
     Errors := IOResult;
     Truncate(DBFile);
     RecCount := Num;
     WriteHeader;

     RecPoint := Pred(NR) *RecordLen +Location;
   end;
   Seek(DBFile,RecPoint);
   Indicator := Pred(NR);
end;

{............................................................................}
procedure TDBF.DeleteRecord(Num : LongInt);
var
 NR : LongInt;
 I : Integer;
 C : Char;

begin
   Errors := 0;

   if (FlagInit <> 123) or
      (FlagHd <> 254) then Exit;

   with DBFHeader do
   begin
     Errors := 0;
     if (RecCount = 0) or (Num > RecCount) then
                        begin
                          Errors := 254;
                          Exit;
                        end;
     case Num of
      0: NR := Indicator;
      else NR := Pred(Num);
     end;

     RecPoint := NR *RecordLen +Location;

     if FilePos(DBFile) <> RecPoint then
       begin
         Seek(DBFile,RecPoint);
         Errors := IOResult;
         if Errors > 0 then Exit;
       end;

     C := '*';
     BlockWrite(DBFile,C,1,I);
     Errors := IOResult;
     if Errors > 0 then Exit;

     Seek(DBFile,RecPoint+RecordLen);
     Errors := IOResult;
     if Errors > 0 then Exit;
   end;
   Indicator := Succ(NR);
end;

{............................................................................}
procedure TDBF.RestoreRecord(Num : LongInt);
var
 NR : LongInt;
 I : Integer;
 C : Char;

begin
   Errors := 0;

   if (FlagInit <> 123) or
      (FlagHd <> 254) then Exit;

   with DBFHeader do
   begin
     Errors := 0;
     if (RecCount = 0) or (Num > RecCount) then
                        begin
                          Errors := 254;
                          Exit;
                        end;
     case Num of
      0: NR := Indicator;
      else NR := Pred(Num);
     end;

     RecPoint := NR *RecordLen +Location;

     if FilePos(DBFile) <> RecPoint then
       begin
         Seek(DBFile,RecPoint);
         Errors := IOResult;
         if Errors > 0 then Exit;
       end;

     C := ' ';
     BlockWrite(DBFile,C,1,I);
     Errors := IOResult;
     if Errors > 0 then Exit;

     Seek(DBFile,RecPoint+RecordLen);
     Errors := IOResult;
     if Errors > 0 then Exit;
   end;
   Indicator := Succ(NR);
end;

{...........................................................................}
function  TDBF.SearchRecord;
var
  S1,S2 : String;
  RNum  : LongInt;
  I : Integer;
begin
  Errors := 0;

  if (FlagInit <> 123) or
     (FlagHd <> 254) then Exit;

  S1 := UpString(SpaceCut(Key));
  if (S1 = '') or (SpaceCut(Field) = '') then Exit;

  if (DbfNdxActv) then
   begin
     for I := 0 to Pred(DbfNdxList^.Count) do
      begin
        RNum := PBaseIx(DbfNdxList^.At(I))^.KeyFind(Key);
        if RNum > 0 then Break;
      end;
   end
      else RNum := 0;

  if RNum <= 0 then  { ᫨    - 饬   䠩 }
   begin
     if Start then RNum := 1 { ᫨   砫 - ⠭ 砫 }
              else RNum := Indicator; {  -   ⥪饩  }

     for RNum := RNum to DBFHeader.RecCount do
     begin
       ReadRecord(RNum);
       S2 := GetField(Field);
       if S1[0] < S2[0] then S2[0] := S1[0];
       if S1 = S2 then Break;
     end;
     if S1 <> S2 then RNum := 0;

   end
    else ReadRecord(RNum);

  SearchRecord := RNum;
end;

{............................................................................}
function  TDBF.CountRecs;
 begin
   CountRecs := DBFHeader.RecCount
 end;

{............................................................................}
function  TDBF.GetFileSize : LongInt;     {  ࠧ    }
begin
  if FlagInit =123 then
   begin
     GetFileSize := FileSize(DBFile);
     if IOResult > 0 then GetFileSize := -1;
   end
  else GetFileSize := -1;
end;

{............................................................................}
function  TDBF.CountDescriptors;
begin
  if FlagInit =123 then CountDescriptors := DescriptorList^.Count;
end;
{............................................................................}
procedure TDBF.GetLastMode(var D,M,Y : Byte);
begin
  with DBFHeader do
   begin
     D := Day;
     M := Month;
     Y := Year;
   end;
end;

{............................................................................}
procedure TDBF.Index (IName : String);
var
   J   : integer;
   St  : String[64];
begin
   if SpaceCut(IName) = '' then Exit;

   if DbfNdxList <> nil then Dispose(DbfNdxList,Done);
   DbfNdxList := New(PCollection,Init(20,5));

   J := 1;
   St := '';

   for J := 1 to Length(IName) do
    begin
      case IName[J] of
       ' ',',': begin
                  if St <> '' then DbfNdxList^.Insert(New(PBaseIX,Init(St)));
                  St := '';
                end;
       'A'..'Z',
       'a'..'z': St := St + IName[J]
      end;
    end;

   if St <> '' then DbfNdxList^.Insert(New(PBaseIX,Init(St)));
   if DbfNdxList^.Count > 0 then DbfNdxActv := True;
end;

{----------------------------------------------------------------------------}
function  RealToString;
var
  S : String;
  L : Integer;
begin
  L := Ln;
  if L > 15 then L := 15;
  Str(D:L:Dc,S);
  RealToString := SpaceCut(S);
end;

{............................................................................}
function  StringToReal;
var
  I  : Integer;
  D  : Double;

begin
  Val(S,D,I);
  if I = 0 then StringToReal := D
           else StringToReal := 0;
end;
{............................................................................}
function  StringToInteger(S: String) : LongInt;
var
  I  : Integer;
  LI : Longint;

begin
  I := Pos('.',S);
  if I > 0 then S[0] := Chr(Pred(Lo(I)));

  Val(S,LI,I);
  if I = 0 then StringToInteger := LI
           else StringToInteger := 0;
end;

{............................................................................}
procedure SetMaxFiles(Count:Word);assembler;
 asm
   Mov AH,67H
   MOV BX,Count
   Int 21H
 end;

{----------------------------------------------------------------------------}
end.

